/*
F
LcdLib.cł́Cn[hIɍȂMD_M52F_48F1AE_H8MB̍͂ȂB
LcdLib.cł́CNbNH8_3052F25H8_3048FONE̍͂ȂB
*/
//}U[̎ނɂ莟̂ǂꂩLɂ邱
// #define MD_M52F_48F1   //ꐻAE_H8MBƊS݊œLED̍Et
#define AE_H8MB     //Hdq
// #define AKI_H8_USB  //Hdq

//}CR̎ނɂ莟̂ǂꂩLɂ邱
#define H8_3048FONE   //25MHz
//#define H8_3048F16  //16MHz
//#define H8_3052F25  //25MHz

//----------------------------------------------------------------------
/*Lcd Library,   AE-H8MB, AKI-H8-USBʃwb_t@C*/
/*mFFHEW Version 4.06.00.047*/
//#include<stdio.h>   ̓vOɋLqȂ

/*VXȅ֌W*/
void init_mother_system(void);          /*}U[{[hVXȅ*/

/*kbcEkdcEXCb`֌W*/
#ifdef MD_M52F_48F1/*2012.2.1ǉ*/
	typedef enum{RIGHT=0x01,LEFT=0x02,ALL=0x03} led_type;
#endif
#ifdef AE_H8MB
	typedef enum{RIGHT=0x02,LEFT=0x01,ALL=0x03} led_type;
#endif
#ifdef AKI_H8_USB
	typedef enum{RIGHT=0x01,LEFT=0x08,ALL=0x0f} led_type;
#endif

void turnOnLed(led_type sel);               /*LED ON*/
void turnOffLed(led_type sel);              /*LED OFF*/
void waitms(unsigned ms);               /*msec҂[v*/
void waitus(unsigned us);               /*sec*/
/* 荞ݏȂꍇ̎l
<3048F16̏ꍇ>
waitms(1000);  1.02s
waitms(100);   100.00ms
waitms(10);    10.20ms
waitms(1);     1.00ms
waitms(0);     2.88us
-
waitus(10000);   10ms
waitus(1000);  1000us
waitus(100); 104.00us
waitus(10);   13.20us
waitus(5);     8.40us
waitus(1);     4.50us
waitus(0);     3.50us

<3052F25̏ꍇ>
waitms(100); 100.00ms
waitms(10);    10.00ms
waitms(1);       1.00ms
waitms(0);       1.76us
-
waitus(1000); 960.00us
waitus(100);   96.00us
waitus(10);    12.40us
waitus(1);       3.60us
waitus(0);       2.80us
*/

void clrscr(void);                      /*kbcʃNA*/
void gotoxy(unsigned x,unsigned y);     /*kbcJ[\ړ*/

void printf(const char *format,...);    /*to*/
void sprintf(char *buffer, const char *format,...);
/*
%[flags][width][.prec][prefix]type
ϊw蕶typeɑ΂āCWi(o)C_(e,E,g,G)C
|C^(n,p)ȊOׂĂɑΉCQi(b)gB
xwq[.prec]͔ΉC
󎚕wq[width]ƃtO[flags]ɂ͊SΉB
GXP[vV[PX́C\\, \n, \r ɑΉB

TviTurbo C Ver5.01J ƓʂɂȂ邱ƂmFρj
printf("test%s","str");              [teststr]
printf("test%5s","str4567890");      [teststr4567890]
printf("test%-5s@","str");           [teststr  @]
printf("test%5s","str");             [test  str]
printf("test%c",'c');                [testc]
printf("test%-5c@",'c');             [testc    @]
printf("test%5c",'c');               [test    c]
printf("test%X",(unsigned)35243);    [test89AB]
printf("test%-#8X@",0x89ab);         [test0X89AB  @]
printf("test%5X",0x89ab);            [test 89AB]
printf("%lx",4294967295);            [ffffffff]
printf("%-#14lX@",16777215);         [0XFFFFFF      @]
printf("%#12lx",16777215);           [    0xffffff]
printf("%#012lx",0x12341234);        [0x0012341234]
printf("%u",(unsigned)0xffff);       [65535]
printf("%-8u@",(unsigned)65535);     [65535   @]
printf("%8u",(unsigned)65535);       [   65535]
printf("%d",32767);                  [32767]
printf("% 8ld@",-32769);             [  -32769@]
printf("%- 8ld@",32768);             [ 32768  @]
printf("%-+8ld@",32769);             [+32769  @]
printf("% -8ld@",32768);             [ 32768  @]
printf("%+-8ld@",32769);             [+32769  @]

Tv@QiɊւăIWig,8bit^(char, unsigned char)̂݁
printf("%08b",0x5c);                 [01011100]
printf("%8b",0x5c);                  [ 1011100]
printf("%4b",0x5c);                  [1100]
printf("%3b",0x5c);                  [100]

*/
typedef enum{ LCD, SCI_1 } devType;
void seldevice(devType device);         /*o͐̑I*/
typedef enum{ C16L2, C20L4 } sizeType;
void lcdsize(sizeType size);    /*o͐̑I*/
void devprintf(devType device,const char *format,...);/*o͐̑Itprintf*/

#define puts(str) {printf("%s\n",str);}  /*l͕ԂȂCst*/
#define putchar(c) {printf("%c",c);}       /*l͕ԂȂ*/
#define putc(c,dev) {devprintf(dev,"%c",c);}/*l͕ԂȂ*/

char *ctoa(char value, char *string, int radix);          /*string9byte*/
char *uctoa(unsigned char value, char *string, int radix);/*string9byte*/
char *itoa(short int value, char *string, int radix);     /*string17byte*/
char *uitoa(unsigned short value, char *string, int radix);/*string17byte*/
char *ltoa(long value, char *string, int radix);          /*string33byte*/
char *ultoa(unsigned long value, char *string, int radix);/*string33byte*/

/*ȑÕo[WƂ̌݊̂߂̃}N*/
#define lcdprints(str) {devprintf(LCD,"%s",str);}
#define lcdprintb(a) {devprintf(LCD,"%08b",a);}
#define lcdprintlb(a) {devprintf(LCD,"%04b",a);}
#define lcdprintub(a) {devprintf(LCD,"%04b",a>>4);}
#define lcdprintx(x) {devprintf(LCD,"%-x",(unsigned)x);}
#define lcdprintX(X) {devprintf(LCD,"%-X",(unsigned)X);}
#define lcdprintc(c) {devprintf(LCD,"%c",c);}

#define initMotherSystem init_mother_system

#define ledon turnOnLed
#define ledoff turnOffLed
